//  prop_dsf.h
//
//	hwdeint dsf property
//
//	Copyright (c) 2005 N099
//
#ifndef _HWDEINTPROP_D_H_
#define _HWDEINTPROP_D_H_

interface IHWDeint;

class CHWDeintProp_DSF : public CBasePropertyPage
{
private:
	IHWDeint *m_pHWDeint;
	DWORD m_merit;
	DWORD m_newmerit;
	std::vector<dsfid> m_dsflist;
	std::vector<dsfid> m_dsflist_all;

	HRESULT ListFilters(void);
	HRESULT EnumClass(CLSID, ICreateDevEnum *);
	HRESULT EnumFilters(void);
	HRESULT ClearFilterList(void);
	HRESULT ParseFilterList(void);
	HRESULT OnClickList(WPARAM wParam, LPARAM lParam);
	HRESULT OnClickMerit(WPARAM wParam);
	DWORD SetMerit(DWORD merit);
	DWORD GetMerit();

	// for sort column
	INT m_sort;
	INT m_sort2;

	bool clicked;

public:
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT * phr);

	CHWDeintProp_DSF(LPUNKNOWN pUnk);
	~CHWDeintProp_DSF() {}

	HRESULT OnConnect(IUnknown *pUnk);
	HRESULT OnActivate(void);
	BOOL OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	HRESULT OnApplyChanges(void);
	HRESULT OnDisconnect(void);

	void SetDirty(void);

	friend int CALLBACK CmpList(LPARAM lP1, LPARAM lP2, LPARAM lPS);
	friend int CALLBACK CmpList2(LPARAM lP1, LPARAM lP2, LPARAM lPS);
};

#endif /* _HWDEINTPROP_D_H_ */
